Index: code/trunk/src/core/CommandLine.h
===================================================================
--- code/trunk/src/core/CommandLine.h	(revision 1937)
+++ code/trunk/src/core/CommandLine.h	(revision 2087)
@@ -35,10 +35,11 @@
 #include "util/Debug.h"
 #include "util/Exception.h"
+#include "util/MultiType.h"
 
 #define SetCommandLineArgument(name, defaultValue) \
-    BaseCommandLineArgument& CmdArgumentDummyBoolVar##name \
+    CommandLineArgument& CmdArgumentDummyBoolVar##name \
     = orxonox::CommandLine::addArgument(#name, defaultValue)
 #define SetCommandLineSwitch(name) \
-    BaseCommandLineArgument& CmdArgumentDummyBoolVar##name \
+    CommandLineArgument& CmdArgumentDummyBoolVar##name \
     = orxonox::CommandLine::addArgument(#name, false)
 
@@ -48,21 +49,20 @@
     /**
     @brief
-        Template struct which creates a distinct type for every integer constant.
-    @note
-        This allows to select a different function depending on a boolean value
-        when creating a new CommandLineArgument.
-        From 'Modern C++ Design' (Alexandrescu 2001).
+        Container class for a command line argument of any type supported by MultiType.
+
+        Whenever you want to have an option specified by a command line switch,
+        you need to first define it with SetCommandLineArgument(name, defaultValue).
+        It is then added to a map and possibly changed when the command line is being parsed.
+        If the option was not given, you can detect this by asking hasDefaultValue().
+
+        There is a possibility to define a short cut so you can write "-p 20" instead of "--port 20".
+        Note the difference between "-" and "--"!
+        Also, there is no restriction to the number of strings you add after --name.
+        So "--startVector (2, 4, 5)" is perfectly legal.
+
+        Retrieving an argument is possible with the getCommandLineArgument function of the
+        CommandLine class. It is a Singleton, but the public interface is static.
     */
-    template <int v>
-    struct Int2Type
-    {
-        enum { value = v };
-    };
-
-    /**
-    @brief
-        Base class for CommandLineArguments.
-    */
-    class _CoreExport BaseCommandLineArgument
+    class _CoreExport CommandLineArgument
     {
         friend class CommandLine;
@@ -78,5 +78,5 @@
         const std::string& getShortcut() const { return shortcut_; }
         //! Sets the shortcut for the argument
-        BaseCommandLineArgument& setShortcut(const std::string& shortcut)
+        CommandLineArgument& shortcut(const std::string& shortcut)
         { this->shortcut_ = shortcut; return *this; }
 
@@ -84,19 +84,27 @@
         const std::string& getInformation() const { return this->usageInformation_; }
         //! Sets the option information when displaying orxonox usage.
-        BaseCommandLineArgument& setInformation(const std::string& usage)
+        CommandLineArgument& information(const std::string& usage)
         { this->usageInformation_ = usage; return *this; }
 
-    protected:
-        BaseCommandLineArgument(const std::string& name)
+        //! Returns the actual value of the argument. Can be equal to default value.
+        MultiType getValue() const { return value_; }
+        //! Returns the given default value as type T.
+        MultiType getDefaultValue() const { return defaultValue_; }
+
+    private:
+        //! Constructor initialises both value_ and defaultValue_ with defaultValue.
+        CommandLineArgument(const std::string& name, const MultiType& defaultValue)
             : bHasDefaultValue_(true)
             , name_(name)
+            , value_(defaultValue)
+            , defaultValue_(defaultValue)
         { }
 
         //! Undefined copy constructor
-        BaseCommandLineArgument(const BaseCommandLineArgument& instance);
-        virtual ~BaseCommandLineArgument() { }
+        CommandLineArgument(const CommandLineArgument& instance);
+        ~CommandLineArgument() { }
 
         //! Parses the value string of a command line argument.
-        virtual void parse(const std::string& value) = 0;
+        void parse(const std::string& value);
 
         //! Tells whether the value has been changed by the command line.
@@ -107,92 +115,8 @@
         std::string shortcut_;         //!< Shortcut of the argument. @see getShortcut().
         std::string usageInformation_; //!< Tells about the usage of this parameter
+
+        MultiType value_;            //!< The actual value
+        MultiType defaultValue_;     //!< Default value. Should not be changed.
     };
-
-
-    /**
-    @brief
-        Container class for a command line argument of type T.
-        
-        Whenever you want to have an option specified by a command line switch,
-        you need to first define it with SetCommandLineArgument(name, defaultValue).
-        It is then added to a map and possibly changed when the command line is being parsed.
-        If the option was not given, you can detect this by asking hasDefaultValue().
-        
-        There is a possibility to define a short cut so you can write "-p 20" instead of "--port 20".
-        Note the difference between "-" and "--"!
-        Also, there is no restriction to the number of strings you add after --name.
-        So "--startVector (2, 4, 5)" is perfectly legal.
-
-        Retrieving an argument is possible with the getCommandLineArgument function of the
-        CommandLine class. It is a Singleton, but the public interface is static.
-    */
-    template <class T>
-    class CommandLineArgument : public BaseCommandLineArgument
-    {
-        // Only let CommandLine change the value.
-        friend class CommandLine;
-
-    public:
-        //! Returns the actual value of the argument. Can be equal to default value.
-        T getValue() const { return value_; }
-        //! Returns the given default value as type T.
-        T getDefaultValue() const { return defaultValue_; }
-
-    private:
-        //! Constructor initialises both value_ and defaultValue_ with defaultValue.
-        CommandLineArgument(const std::string& name, const T& defaultValue)
-            : BaseCommandLineArgument(name)
-            , value_(defaultValue)
-            , defaultValue_(defaultValue)
-        { }
-
-        virtual void parse(const std::string& value);
-
-        T value_;            //!< The actual value
-        T defaultValue_;     //!< Default value. Should not be changed.
-    };
-
-    /**
-    @brief
-        Parses a value string for a command line argument.
-        It simply uses convertValue(Output, Input) to do that.
-    */
-    template <class T>
-    void CommandLineArgument<T>::parse(const std::string& value)
-    {
-        if (convertValue(&this->value_, value))
-        {
-            this->bHasDefaultValue_ = false;
-        }
-        else
-        {
-            ThrowException(Argument, "Could not read command line argument '" + getName() + "'.");
-        }
-    }
-
-    /**
-    @brief
-        Parses a value string for a command line argument.
-        It simply uses convertValue(Output, Input) to do that.
-        This is a template specialisation for bool type. That is necessary
-        so that you can have simple command line switches.
-    */
-    template <>
-    inline void CommandLineArgument<bool>::parse(const std::string& value)
-    {
-        if (convertValue(&this->value_, value))
-        {
-            this->bHasDefaultValue_ = false;
-        }
-        else if (value == "")
-        {
-            this->bHasDefaultValue_ = false;
-            this->value_ = true;
-        }
-        else
-        {
-            ThrowException(Argument, "Could not read command line argument '" + getName() + "'.");
-        }
-    }
 
 
@@ -215,12 +139,20 @@
         static std::string getUsageInformation();
 
-        template <class T>
-        static const CommandLineArgument<T>* getArgument(const std::string& name);
+        static const CommandLineArgument* getArgument(const std::string& name);
         //! Writes the argument value in the given parameter.
         template <class T>
         static void getValue(const std::string& name, T* value)
-        { *value = getArgument<T>(name)->getValue(); }
+        { *value = (T)(getArgument(name)->getValue()); }
+        static MultiType getValue(const std::string& name)
+        { return getArgument(name)->getValue(); }
         template <class T>
-        static BaseCommandLineArgument& addArgument(const std::string& name, T defaultValue);
+        static CommandLineArgument& addArgument(const std::string& name, T defaultValue);
+
+        static bool existsArgument(const std::string& name)
+        {
+            std::map<std::string, CommandLineArgument*>::const_iterator it = _getInstance().cmdLineArgs_.find(name);
+            return !(it == _getInstance().cmdLineArgs_.end());
+        }
+
 
     private:
@@ -237,11 +169,6 @@
         void checkShortcut(const std::string& shortcut, const std::string& value);
 
-        template <class T>
-        BaseCommandLineArgument* createArg(const std::string& name, T defaultValue, Int2Type<0> isString);
-        template <class T>
-        BaseCommandLineArgument* createArg(const std::string& name, T defaultValue, Int2Type<1> isString);
-
         /**
-            Tells whether we parse the first expression. The CommmandLineArguments are added before main().
+            Tells whether we parsed for the first time. The CommmandLineArguments are added before main().
             So when we call parse() the first time, we need to create a map with all shortcuts since these
             get added after addCommandLineArgument().
@@ -250,38 +177,13 @@
 
         //! Holds all pointers to the arguments and serves as a search map by name.
-        std::map<std::string, BaseCommandLineArgument*> cmdLineArgs_;
+        std::map<std::string, CommandLineArgument*> cmdLineArgs_;
         //! Search map by chortcut for the arguments.
-        std::map<std::string, BaseCommandLineArgument*> cmdLineArgsShortcut_;
+        std::map<std::string, CommandLineArgument*> cmdLineArgsShortcut_;
     };
 
-
-    /**
-    @brief
-        Retrieves a CommandLineArgument.
-        The method throws an exception if 'name' was not found or the value could not be converted.
-    @note
-        You shold of course not call this method before the command line has been parsed.
-    */
-    template <class T>
-    const CommandLineArgument<T>* CommandLine::getArgument(const std::string& name)
-    {
-        std::map<std::string, BaseCommandLineArgument*>::const_iterator it = _getInstance().cmdLineArgs_.find(name);
-        if (it == _getInstance().cmdLineArgs_.end())
-        {
-            ThrowException(Argument, "Could find command line argument '" + name + "'.");
-        }
-        else
-        {
-            CommandLineArgument<T>* arg = dynamic_cast<CommandLineArgument<T>* >(it->second);
-            if (arg == 0)
-            {
-                ThrowException(Argument, "Could not convert command line argument value to requested type. " \
-                    "You should use exactly the same type as predefined.");
-            }
-            else
-            {
-                return arg;
-            }
-        }
+    template <>
+    inline void CommandLine::getValue<std::string>(const std::string& name, std::string* value)
+    {
+        *value = (std::string)(getArgument(name)->getValue().getString());
     }
 
@@ -294,38 +196,12 @@
     @param defaultValue
         Default value that is used when argument was not given.
-    @note
-        In order to store char* strings as std::string too, there's
-        little bit of template programming involved:
-        StaticConversions::exists determines whether T converts to std::string.
-        Int2Type<int> is then used to call the right function. One returns
-        a CommandLineArgument<T> and the other CommandLineArgument<std::string>.
     */
     template <class T>
-    BaseCommandLineArgument& CommandLine::addArgument(const std::string& name, T defaultValue)
-    {
-        std::map<std::string, BaseCommandLineArgument*>::const_iterator it = _getInstance().cmdLineArgs_.find(name);
-        OrxAssert(it == _getInstance().cmdLineArgs_.end(),
+    CommandLineArgument& CommandLine::addArgument(const std::string& name, T defaultValue)
+    {
+        OrxAssert(!_getInstance().existsArgument(name),
             "Cannot add a command line argument with name '" + name + "' twice.");
 
-        return *(_getInstance().cmdLineArgs_[name] = 
-            _getInstance().createArg(name, defaultValue, Int2Type<StaticConversion<T, std::string>::exists>()));
-    }
-
-    /**
-        Returns a new CommandLineArgument<T>.
-    */
-    template <class T>
-    BaseCommandLineArgument* CommandLine::createArg(const std::string& name, T defaultValue, Int2Type<0> isPrime)
-    {
-        return new CommandLineArgument<T>(name, defaultValue);
-    }
-
-    /**
-        Returns a new CommandLineArgument<std::string>.
-    */
-    template <class T>
-    BaseCommandLineArgument* CommandLine::createArg(const std::string& name, T defaultValue, Int2Type<1> isPrime)
-    {
-        return new CommandLineArgument<std::string>(name, defaultValue);
+        return *(_getInstance().cmdLineArgs_[name] = new CommandLineArgument(name, defaultValue));
     }
 }
Index: code/trunk/src/core/ConfigValueContainer.h
===================================================================
--- code/trunk/src/core/ConfigValueContainer.h	(revision 1937)
+++ code/trunk/src/core/ConfigValueContainer.h	(revision 2087)
@@ -52,4 +52,5 @@
 #include "util/MultiType.h"
 #include "ConfigFileManager.h"
+#include "Identifier.h"
 
 namespace orxonox
@@ -69,5 +70,5 @@
             inline virtual ~ConfigValueCallback() {}
             inline virtual void call(void* object)
-                { (((T*)object)->*this->function_)(); }
+                { if (!Identifier::isCreatingHierarchy()) { (((T*)object)->*this->function_)(); } }
 
         private:
Index: code/trunk/src/core/ConsoleCommand.cc
===================================================================
--- code/trunk/src/core/ConsoleCommand.cc	(revision 1937)
+++ code/trunk/src/core/ConsoleCommand.cc	(revision 2087)
@@ -41,6 +41,5 @@
 
         this->keybindMode_ = KeybindMode::OnPress;
-        this->axisParamIndex_ = -1;
-        this->bAxisRelative_ = false;
+        this->inputConfiguredParam_ = -1;
     }
 
Index: code/trunk/src/core/ConsoleCommand.h
===================================================================
--- code/trunk/src/core/ConsoleCommand.h	(revision 1937)
+++ code/trunk/src/core/ConsoleCommand.h	(revision 2087)
@@ -122,4 +122,12 @@
                 { return this->argumentList_.end(); }
 
+            inline ConsoleCommand& setAsInputCommand()
+            {
+                this->keybindMode(KeybindMode::OnHold);
+                this->defaultValue(0, Vector2(0.0f, 0.0f));
+                this->inputConfiguredParam(0);
+                return *this;
+            }
+
             inline ConsoleCommand& keybindMode(KeybindMode::Enum mode)
                 { this->keybindMode_ = mode; return *this; }
@@ -127,13 +135,8 @@
                 { return this->keybindMode_; }
 
-            inline ConsoleCommand& axisParamIndex(int index)
-                { this->axisParamIndex_ = index; return *this; }
-            inline int getAxisParamIndex() const
-                { return this->axisParamIndex_; }
-
-            inline ConsoleCommand& isAxisRelative(bool val)
-                { this->bAxisRelative_ = val; return *this; }
-            inline int getIsAxisRelative() const
-                { return this->bAxisRelative_; }
+            inline ConsoleCommand& inputConfiguredParam(int index)
+                { this->inputConfiguredParam_ = index; return *this; }
+            inline int getInputConfiguredParam_() const
+                { return this->inputConfiguredParam_; }
 
         private:
@@ -143,6 +146,5 @@
 
             KeybindMode::Enum keybindMode_;
-            int axisParamIndex_;
-            bool bAxisRelative_;
+            int inputConfiguredParam_;
     };
 
Index: code/trunk/src/core/Core.cc
===================================================================
--- code/trunk/src/core/Core.cc	(revision 1937)
+++ code/trunk/src/core/Core.cc	(revision 2087)
@@ -37,9 +37,13 @@
 #include "CoreIncludes.h"
 #include "ConfigValueIncludes.h"
-//#include "input/InputManager.h"
-//#include "TclThreadManager.h"
 
 namespace orxonox
 {
+    bool Core::bShowsGraphics_s = false;
+    bool Core::bHasServer_s     = false;
+    bool Core::bIsClient_s      = false;
+    bool Core::bIsStandalone_s  = false;
+    bool Core::bIsMaster_s      = false;
+
     /**
         @brief Constructor: Registers the object and sets the config-values.
@@ -205,14 +209,3 @@
         ResetConfigValue(language_);
     }
-
-    ///**
-    //    @brief Ticks every core class in a specified sequence. Has to be called
-    //           every Orxonox tick!
-    //    @param dt Delta Time
-    //*/
-    //void Core::tick(float dt)
-    //{
-    //    TclThreadManager::getInstance().tick(dt);
-    //    InputManager::getInstance().tick(dt);
-    //}
 }
Index: code/trunk/src/core/Core.h
===================================================================
--- code/trunk/src/core/Core.h	(revision 1937)
+++ code/trunk/src/core/Core.h	(revision 2087)
@@ -60,5 +60,15 @@
             static void resetLanguage();
 
-            //static void tick(float dt);
+            // fast access global variables.
+            static bool showsGraphics() { return bShowsGraphics_s; }
+            static bool hasServer()     { return bHasServer_s; }
+            static bool isClient()      { return bIsClient_s; }
+            static bool isStandalone()  { return bIsStandalone_s; }
+            static bool isMaster()      { return bIsMaster_s; }
+            static void setShowsGraphics(bool val) { bShowsGraphics_s = val; updateIsMaster(); }
+            static void setHasServer    (bool val) { bHasServer_s     = val; updateIsMaster(); }
+            static void setIsClient     (bool val) { bIsClient_s      = val; updateIsMaster(); }
+            static void setIsStandalone (bool val) { bIsStandalone_s  = val; updateIsMaster(); }
+            static void updateIsMaster  ()         { bIsMaster_s      = (bHasServer_s || bIsStandalone_s); }
 
         private:
@@ -74,4 +84,10 @@
             int softDebugLevelShell_;                       //!< The debug level for the ingame shell
             std::string language_;                          //!< The language
+
+            static bool bShowsGraphics_s;                   //!< global variable that tells whether to show graphics
+            static bool bHasServer_s;                       //!< global variable that tells whether this is a server
+            static bool bIsClient_s;
+            static bool bIsStandalone_s;
+            static bool bIsMaster_s;
     };
 }
Index: code/trunk/src/core/CoreIncludes.h
===================================================================
--- code/trunk/src/core/CoreIncludes.h	(revision 1937)
+++ code/trunk/src/core/CoreIncludes.h	(revision 2087)
@@ -46,4 +46,5 @@
 #include "Factory.h"
 #include "ClassFactory.h"
+#include "Functor.h"
 #include "util/Debug.h"
 
@@ -98,5 +99,12 @@
 */
 #define CreateFactory(ClassName) \
-    bool bCreated##ClassName##Factory = orxonox::ClassFactory<ClassName>::create(#ClassName)
+    bool bCreated##ClassName##Factory = orxonox::ClassFactory<ClassName>::create(#ClassName, true)
+
+/**
+    @brief Creates the entry in the Factory for classes which should not be loaded through XML.
+    @param ClassName The name of the class
+*/
+#define CreateUnloadableFactory(ClassName) \
+    bool bCreated##ClassName##Factory = orxonox::ClassFactory<ClassName>::create(#ClassName, false)
 
 /**
@@ -105,5 +113,5 @@
 */
 #define Class(ClassName) \
-    ClassIdentifier<ClassName>::getIdentifier()
+    orxonox::ClassIdentifier<ClassName>::getIdentifier()
 
 /**
@@ -111,5 +119,5 @@
     @param String The name of the class
 */
-#define ClassByName(String) \
+#define ClassByString(String) \
     orxonox::Factory::getIdentifier(String)
 
@@ -121,3 +129,11 @@
     orxonox::Factory::getIdentifier(networkID)
 
+/**
+    @brief Registers a member function as callback when an object of 'type' is created.
+    @param
+*/
+#define RegisterConstructionCallback(ThisClassName, TargetClassName, FunctionName) \
+    orxonox::ClassIdentifier<TargetClassName>::getIdentifier()->addConstructionCallback( \
+        createFunctor(&ThisClassName::FunctionName)->setObject(this))
+
 #endif /* _CoreIncludes_H__ */
Index: code/trunk/src/core/CorePrereqs.h
===================================================================
--- code/trunk/src/core/CorePrereqs.h	(revision 1937)
+++ code/trunk/src/core/CorePrereqs.h	(revision 2087)
@@ -103,6 +103,4 @@
   class CommandExecutor;
   class CommandLine;
-  class BaseCommandLineArgument;
-  template <class T>
   class CommandLineArgument;
   class ConfigFile;
@@ -115,4 +113,6 @@
   class ConsoleCommand;
   class Core;
+  struct Event;
+  class EventContainer;
   class Executor;
   template <class T>
@@ -131,5 +131,4 @@
   class Language;
   class LanguageEntry;
-  class Level;
   class Loader;
   class MetaObjectList;
@@ -153,5 +152,8 @@
   struct TclInterpreterBundle;
   class TclThreadManager;
+  class Template;
   class Tickable;
+  class XMLFile;
+  class XMLNameListener;
   template <class T, class O>
   class XMLPortClassObjectContainer;
Index: code/trunk/src/core/Event.cc
===================================================================
--- code/trunk/src/core/Event.cc	(revision 2087)
+++ code/trunk/src/core/Event.cc	(revision 2087)
@@ -0,0 +1,78 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Event.h"
+#include "BaseObject.h"
+#include "Executor.h"
+
+namespace orxonox
+{
+    EventContainer::~EventContainer()
+    {
+        delete this->eventfunction_;
+    }
+
+    void EventContainer::process(BaseObject* object, const Event& event)
+    {
+        if (this->bActive_)
+        {
+            COUT(2) << "Warning: Detected Event loop in section \"" << this->eventname_ << "\" of object \"" << object->getName() << "\" and fired by \"" << event.originator_->getName() << "\"" << std::endl;
+            return;
+        }
+
+        this->bActive_ = true;
+
+        if (this->eventname_ == event.sectionname_)
+        {
+            if (event.originator_->isA(this->subclass_))
+            {
+                if (event.activate_)
+                    ++this->activeEvents_;
+                else
+                {
+                    --this->activeEvents_;
+
+                    if (this->activeEvents_ < 0)
+                        this->activeEvents_ = 0;
+                }
+
+                if (this->eventfunction_->getParamCount() == 0 && event.activate_)
+                    (*this->eventfunction_)();
+                else if ((this->activeEvents_ == 1 && event.activate_) || (this->activeEvents_ == 0 && !event.activate_))
+                {
+                    if (this->eventfunction_->getParamCount() == 1)
+                        (*this->eventfunction_)(this->activeEvents_);
+                    else if (this->eventfunction_->getParamCount() >= 2 && event.castedOriginator_)
+                        (*this->eventfunction_)(this->activeEvents_, event.castedOriginator_);
+                }
+            }
+        }
+
+        this->bActive_ = false;
+    }
+}
Index: code/trunk/src/core/Event.h
===================================================================
--- code/trunk/src/core/Event.h	(revision 2087)
+++ code/trunk/src/core/Event.h	(revision 2087)
@@ -0,0 +1,64 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Event_H__
+#define _Event_H__
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+    struct _CoreExport Event
+    {
+            Event(bool activate, BaseObject* originator) : activate_(activate), originator_(originator), castedOriginator_(0) {}
+
+            bool        activate_;
+            BaseObject* originator_;
+            void*       castedOriginator_;
+            std::string sectionname_;
+    };
+
+    class _CoreExport EventContainer
+    {
+        public:
+            EventContainer(const std::string& eventname, Executor* eventfunction, Identifier* subclass) : bActive_(false), eventname_(eventname), eventfunction_(eventfunction), subclass_(subclass), activeEvents_(0) {}
+            virtual ~EventContainer();
+
+            void process(BaseObject* object, const Event& event);
+
+        private:
+            bool bActive_;
+            std::string eventname_;
+            Executor* eventfunction_;
+            Identifier* subclass_;
+
+            int activeEvents_;
+    };
+}
+
+#endif /* _Event_H__ */
Index: code/trunk/src/core/EventIncludes.h
===================================================================
--- code/trunk/src/core/EventIncludes.h	(revision 2087)
+++ code/trunk/src/core/EventIncludes.h	(revision 2087)
@@ -0,0 +1,71 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _EventIncludes_H__
+#define _EventIncludes_H__
+
+#include "CorePrereqs.h"
+#include "Executor.h"
+
+#define SetEvent(classname, eventname, functionname, event) \
+    SetEventGeneric(eventcontainer##classname##functionname, classname, eventname, functionname, event, BaseObject)
+
+#define SetEventTemplate(classname, eventname, functionname, event, ...) \
+    SetEventGenericTemplate(eventcontainer##classname##functionname, classname, eventname, functionname, event, BaseObject, __VA_ARGS__)
+
+#define SetSubclassEvent(classname, eventname, functionname, event, subclassname) \
+    SetEventGeneric(eventcontainer##classname##functionname, classname, eventname, functionname, event, subclassname)
+
+#define SetSubclassEventTemplate(classname, eventname, functionname, event, subclassname, ...) \
+    SetEventGenericTemplate(eventcontainer##classname##functionname, classname, eventname, functionname, event, subclassname, __VA_ARGS__)
+
+#define SetEventGeneric(containername, classname, eventname, functionname, event, subclassname) \
+    orxonox::EventContainer* containername = this->getEventContainer(eventname); \
+    if (!containername) \
+    { \
+        ExecutorMember<classname>* executor = orxonox::createExecutor(orxonox::createFunctor(&classname::functionname), std::string( #classname ) + "::" + #functionname); \
+        executor->setObject(this); \
+        containername = new orxonox::EventContainer(std::string(eventname), executor, orxonox::ClassIdentifier<subclassname>::getIdentifier()); \
+        this->addEventContainer(eventname, containername); \
+    } \
+    event.castedOriginator_ = dynamic_cast<subclassname*>(event.originator_); \
+    containername->process(this, event)
+
+#define SetEventGenericTemplate(containername, classname, eventname, functionname, event, subclassname, ...) \
+    orxonox::EventContainer* containername = this->getEventContainer(eventname); \
+    if (!containername) \
+    { \
+        ExecutorMember<classname>* executor = orxonox::createExecutor(orxonox::createFunctor<classname, __VA_ARGS__ >(&classname::functionname), std::string( #classname ) + "::" + #functionname); \
+        executor->setObject(this); \
+        containername = new orxonox::EventContainer(std::string(eventname), executor, orxonox::ClassIdentifier<subclassname>::getIdentifier()); \
+        this->addEventContainer(eventname, containername); \
+    } \
+    event.castedOriginator_ = dynamic_cast<subclassname*>(event.originator_); \
+    containername->process(this, event)
+
+#endif /* _EventIncludes_H__ */
